/*+
|                                               |
|     Trigger: DTULTATU_PRODTIPOSUPRI           |  
|     Tabela : PRODTIPOSUPRI                    |
|                                               |
|     Criao:                                  |
|     31/03/2009 - Leonardo Bispo               |
|                                               |
+*/

create or replace TRIGGER DTULTATU_PRODTIPOSUPRI
BEFORE INSERT OR UPDATE OR DELETE
ON PRODTIPOSUPRI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRODTPS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOSUPRI,0)   <> NVL(:NEW.CDTIPOSUPRI,0))   OR
         (NVL(:OLD.CDPRODUTO,0)     <> NVL(:NEW.CDPRODUTO,0))     OR
         (NVL(:OLD.VRLIMITEPROD,0)  <> NVL(:NEW.VRLIMITEPROD,0))  OR
         (NVL(:OLD.IDREEMBVRPROD,0) <> NVL(:NEW.IDREEMBVRPROD,0)) THEN 
           
              :NEW.DTULTATUPRODTPS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODTIPOSUPRI',
                               '',
                               'CDTIPOSUPRI='||:OLD.CDTIPOSUPRI||';CDPRODUTO='||:OLD.CDPRODUTO||';',
                               SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODTIPOSUPRI MODIFY DTULTATUPRODTPS DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PRODTIPOSUPRI','5.07.015'); END;
/
